'use strict';

exports.__esModule = true;

var _react = require('react');

var _createReactContext2 = require('create-react-context');

var _createReactContext3 = _interopRequireDefault(_createReactContext2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var createMutableContext = function createMutableContext(globalWithState) {
  var _createReactContext = (0, _createReactContext3.default)({}),
      Provider = _createReactContext.Provider,
      Consumer = _createReactContext.Consumer;

  var runWithState = function runWithState(updates, prevState, props) {
    if (globalWithState) updates = globalWithState(updates, prevState, props);
    var withState = props.withState;

    if (withState) updates = withState(updates, prevState, props);
    return updates;
  };

  var wrapUpdater = function wrapUpdater(updater) {
    return function (prevState, props) {
      var updates = typeof updater === 'function' ? updater(prevState, props) : updater;
      return runWithState(updates, prevState, props);
    };
  };

  var MutableProvider = function (_Component) {
    _inherits(MutableProvider, _Component);

    function MutableProvider() {
      var _temp, _this, _ret;

      _classCallCheck(this, MutableProvider);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = runWithState(Object.assign({}, _this.props.defaultState, {
        // eslint-disable-next-line react/no-unused-state
        setState: function setState(updater, callback) {
          return _this.setState(wrapUpdater(updater), callback);
        }
      }), {}, _this.props), _temp), _possibleConstructorReturn(_this, _ret);
    }

    MutableProvider.prototype.render = function render() {
      return (0, _react.createElement)(Provider, { value: this.state }, this.props.children);
    };

    return MutableProvider;
  }(_react.Component);

  return {
    Provider: MutableProvider,
    Consumer: Consumer
  };
};

exports.default = createMutableContext;